#include <stdio.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <X11/Box.h>
#include <X11/Dialog.h>
#include <X11/Command.h>
#include <X11/Label.h>
#include <X11/List.h>
#include <X11/Form.h>
#include <X11/StringDefs.h>
#include <X11/AsciiText.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>


/* Used in LEVELMONITOR.C */

#define MONITOR_HEIGHT 426  /* used for overall monitor widget */
#define MONITOR_WIDTH 790  /* used for overall monitor widget */
#define MONITOR_INSIDE_WIDTH 260
#define TITLE_HEIGHT 20
#define OPEN_WIDTH 100   /* used for Open/Close menu */
#define OPEN_HEIGHT 60   /* used for Open/Close menu */


/* Used in RuleDisplayParamCreate.C */
#define STATUS_WIDTH  770 /* used for level status widget */

#define INSIDE_LEVEL_WIDTH  260  /* used for the graphic widget */
#define INSIDE_LEVEL_HEIGHT 80  /* used for the graphic widget */


#define AGAIN_TITLE_HEIGHT  20  /* used for all title widget */
#define AGAIN_MENU_HEIGHT  80  /* used for menu inside status area */
#define AGAIN_MENU_WIDTH  20  /* used for  menu inside status area */

/* Used in Colour.c */
#define COLOUR_WIDTH 60
#define COLOUR_HEIGHT 40 
#define RED 150
#define GREEN 120
#define BLUE 30
#define BIG_COLOUR_WIDTH 200
#define BIG_COLOUR_HEIGHT 50


/* Used in system.c net.c layer.c cluster.c and neuron.c */
/* for the probe menu */
/* Should change according to the level */
#define MENU_WIDTH 120
#define MENU_HEIGHT 70
#define SCALE_MENU_HEIGHT 90

/* Used in Select.c */
#define SELECT_WIDTH 200
#define SELECT_HEIGHT 70
#define SELECT_BUTTON_HEIGHT 20
#define SELECT_BUTTON_WIDTH 90


/* Used in RuleCreate.c and LevelRuleCreate.c */
#define RULE_HEIGHT 20
#define RULE_WIDTH 100 

/* Used in PartamCreate.c */
#define TEXT_WIDTH 150  
#define PARAM_HEIGHT 20  



/* Facticious Definition */

/* for the RULES */
typedef struct {
                char *name ;
                int *executable ;
                }  rule_information ;


/* for the PARAM */
typedef struct {
                char *name ;
                char *value ;
                }  param_information ;


/* used within Select.c and Interconnect.c */
typedef struct {
         Widget  mikeneed   ;
         Widget  firstmenu  ;
         Widget  nowmenu   ;
         Widget  nowform   ;
               } FamilyWidget ;

/* RESTRICTIONS = CAN ONLY CREATE 25 LEVEL WINDOW  */
/* used within FilledFamily.c  */
typedef struct {
         Widget  widgetid[26] ;  /* level display id */
         int  associated_path[26][4] ; /* associated path */
         int  connect_flag[26]  ;  /* 0=> !connection 1=> connection*/
         int first_path[26][4] ; /* FROM path */
         int second_path[26][4] ; /* TO path */
	 int mattrix_flag[26] ;  /* 0=> linear display; 1=> mattrixdisplay */
/* COMMENTS = Here i do not need to have dimension associated with */
/* each LWindow => global field */
         int input_dim[2] ;     /* dimension for input mattrix */
         int output_dim[2] ;   /* dimension for output mattrix */
               } FamilyUpdate ;

/* Used in InterconnectCreate.c */
/* Declaration of the struct to pass param to each callback */
typedef struct  {
                int path_current[4] ;
                int path_inter1[4] ;
                int path_inter2[4] ;
                int flag_inter ;
                Widget drawing ; /* for mike */
                Widget kill ;
                Widget hurt ;
                char low_colour ;
                char high_colour ;
                 } InterconnectStructure;

/* Used in Colour.c */
/* Declaration of the struct to pass param to each callback */
typedef struct  {
                int path_current[4] ;
                Widget drawing ; /* for mike */
                Widget kill ;
                Widget hurt ;
                char low_colour ;
                char high_colour ;
                 } ColourStructure;

/* Used in AssocColour.c AND ExpandScale.c */
/* Declaration of the struct to pass param to each callback */
  typedef struct {
                  int theroute[4] ;
                  Widget tokill ;
                  Widget tohurt ;
                 } AssocStruct ;

#define NULL_ASSOC_STRUCT (AssocStruct *) 0

