/******************************************************************************/
/**									     **/
/**		      Copyright 1990 by Computer Science Dept.  	     **/
/**			University College London, England		     **/
/**									     **/
/**				                  			     **/
/**									     **/
/** Permission to use, copy and modify (but NOT distribute) this software    **/
/** and its documentation for any purpose and without fee is hereby granted, **/
/** provided the above copyright notice appears in all copies, and that both **/
/** that copyright notice and this permission notice appear in supporting    **/
/** documentation, and that the name Pygmalion not be used in advertising or **/
/** publicity of the software without specific, written prior permission of  **/
/** Thomson-CSF.							     **/
/**									     **/
/** THE DEPARTMENT OF COMPUTER SCIENCE, UNIVERSITY COLLEGE LONDON DISCLAIMS  **/
/** ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED       **/
/** WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE 	     **/
/** DEPARTMENT OF COMPUTER SCIENCE, UNIVERSITY COLLEGE LONDON BE LIABLE FOR  **/
/** ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER **/
/** RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF     **/
/** CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN      **/
/** CONJUNCTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.		     **/
/**									     **/
/******************************************************************************/

/******************************************************************************
 * Pygmalion Programming Environment v 1.01 30/1/90
 *
 * pgm 
 *
 * 
 ******************************************************************************/

#include "myheader.h"
#include "everything.h"

extern Widget overall ;

/* Args for big_totake, shell widget */
Arg Errtoptoptotake_arg[] = {
		{XtNx, (XtArgVal) NULL},
		{XtNy, (XtArgVal) NULL},
		{XtNborderWidth, (XtArgVal)3},
                {XtNlabel, (XtArgVal)"ERROR HANDLER"}};

/* Args for top_totake, form widget */
Arg toptotake_arg[] = {
                {XtNlabel, (XtArgVal)"Message"},
        } ;

Arg thetitle_arg[] = {
                {XtNvertDistance, (XtArgVal)1},
                {XtNheight, (XtArgVal)ERROR_height},
                {XtNwidth, (XtArgVal)ERROR_WIDTH},
		{XtNborderWidth, (XtArgVal) 0},
        };
Arg Errtotake_arg[] = {
                {XtNfile, (XtArgVal)NULL},
                {XtNvertDistance, (XtArgVal)1},
         	{XtNeditType, (XtArgVal)XttextRead},
                {XtNheight, (XtArgVal)200},
                {XtNwidth, (XtArgVal)250},
		{XtNborderWidth, (XtArgVal) 0},
        };

/* TRY TO HANDLE DIFFERENT ERROR
 * BY POP UP AN EXPLANATION OF THE ERROR
 * THE POP UP IS CHILD OF OVERALL
 */


/* CALLBACK TO KILL THE ERROR WIDGET (ie big_totake) */
void The_title (initiateur, client_data, call_data)
/*
 * the widget w represents the
 * widget the_title and NOTbig totake which is client_data  
 */
Widget initiateur;
caddr_t client_data;  /* used to pass the shell widget */
caddr_t call_data;     /* not used  */
{

/* cast the type */
Widget theonetokill = (Widget)client_data ;

/*        XtPopdown(theonetokill) ;*/
XtUnmapWidget(theonetokill) ;

  } 


/*----------------------------------------------*/
/* TAKE THE FILE WHERE THE EXPLANATION IS TO  DISPLAY IT	*/
/*----------------------------------------------*/
/* type_error = which kind of error :
 *	0 = Start a simulation without loading properly
 * 	1 = The user asked for a wrong new simulation Status 
 *	3 = No proper Init 
 *	4 = Try to load  a file on top of an existing one
 *	5 = Try to save a model or output while no load  
 *	6 = Try to execute a rule while the simulation is suspended
 *	7 = Bad path for an openeing of level window
 *	8 = Bad interconnect members 
 * 	13 = Bad input filename
 * 	
 *	15 = Current window is too narrow to draw graphics in properly
 *	16 = Current window is too short to draw graphics in properly
 *	17 = Selected components to view with connection matrix are 
 *	     not connected!
 *	18 = draw?layer? called but no components to display
	19 = EDITOR environment variable not set - instruct object
	     how to set this!
 *	22 = N not integrated
 * 	23 = can not open 2 nC top window
 *
	100 = *****TEMP**** mikes draw_layer_connection is
	                    passed wrong info at the mo
 */

 
void Error(type_error)
int type_error ;     
{
Widget  big_totake ,
	    top_totake ,
		the_title ,
		to_take ;
Window junk_win;
int x_root, y_root,garbage;
unsigned int garbage_mask;

char buffy[200] ;
extern Arg Errtoptoptotake_arg[4];
extern Arg toptotake_arg[1];
extern Arg thetitle_agr[4];
extern Arg Errtotake_arg[6];

/* Change the cursor */
 Cursor thecursor ; Display *thedisplay ; Window thewindow ;

/*----------------------------------------------*/
/* ARGUMENTS 					*/ 
/*----------------------------------------------*/


/*----------------------------------------------*/
/* CREATE 					*/ 
/*----------------------------------------------*/
    big_totake = XtCreatePopupShell("toptoptakeinput",
                                overrideShellWidgetClass,
                                overall,
                                Errtoptoptotake_arg,
                                XtNumber(Errtoptoptotake_arg));

       top_totake = XtCreateManagedWidget("toptakerror",
                                formWidgetClass,
                                big_totake,
                                toptotake_arg,
                                XtNumber(toptotake_arg));


          the_title = XtCreateManagedWidget("   Acknowleged   ",
                                commandWidgetClass,
                                top_totake,
                                thetitle_arg,
                                XtNumber(thetitle_arg));



/* According to the type of error load a different file */

switch (type_error) 
	{
	 case 0 : sprintf(buffy , "%s/%s" , 
			rc[RC_error_message_directory] , "ERROR.comit") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 1 :  
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] , "ERROR.state") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 2 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] , "ERROR.loadall") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 3 :  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.init") ;
	          XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 4 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] , "ERROR.config") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 5 :
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.save") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 6 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.suspended") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 7 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.path") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 8 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.inter") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 9 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.select") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 10 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.start1") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 11 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.system.save") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 12 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.algolib") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 13 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.patternfile") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 14 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.patternload") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
		  break ;
	 case 15 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.narrow") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;
	 case 16 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.short") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;
	 case 17 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.connection") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;
	 case 18 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.nothing_to_draw") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;
	 case 19 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.no_EDITOR_set") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;
         case 20 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.no_synapses") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 21 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.no_input") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 22 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.HLL") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 23 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.onenCtop") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 25 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.noneuron0") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 26 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.nonalgoconfig") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 27 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.algonot") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 28 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.inputtarget") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 29 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.needalgo") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

/* too many patterns in the pattern descriptor */
         case 30 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.manypat") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
/* not about error ; just warning */
/* not about error ; just warning */
/* not about error ; just warning */
         case 50 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.reloading") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 51 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.patterns") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

/* about the remote creation of the sver */
         case 60 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.server") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 61 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.InternetPort") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 62 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.killserv") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

/* About filename */
         case 70 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.emptyname") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 71 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.wrongappli") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 72 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.wrongdata") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 73 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.wrongconfig") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;

         case 74 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.wronginput") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;


/* About batch execution */
         case 80 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.endappli") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 81 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.cantopenappli") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 83 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.execalready") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 84 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.unknownrule") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
         case 85 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "MSG.cantexec") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;





	 case 100 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ERROR.mikes_temporary_error_as_given_wrong_info") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
	 	  break;

/* Message about RPC */
     case 200 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "WeightRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 201 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,   "StatusRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 202 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "InitRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 203 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ConfRPC" ) ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 204 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] , "SaveRPC" ) ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 205 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "RandWeightRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 206 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ParamRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 207 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "RuleRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 208 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "PatternRPC") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;


/* RPC Connection reset */
     case 299 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "ResetRPC" ) ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;


     case 300 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "SystemPARAM" ) ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 301 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,  "NetPARAM" ) ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 302 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,   "LayerPARAM") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 303 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,   "ClusterPARAM") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
     case 304 : 
		  sprintf(buffy , "%s/%s" ,
                        rc[RC_error_message_directory] ,   "NeuronPARAM") ;
		  XtSetArg(Errtotake_arg[0],XtNfile, buffy) ;
                  break;
	} ;



          to_take = XtCreateManagedWidget("takeinput",
                                asciiDiskWidgetClass,
                                top_totake,
                                Errtotake_arg,
                                XtNumber(Errtotake_arg));




/* Add the callback in order to have the widget big_totake */
/* known by the callback in order to Pop it down */
XtAddCallback(the_title, XtNcallback,
                The_title, (caddr_t)big_totake) ;



/* REALIZE */
/*XtPopup(big_totake, XtGrabNone) ;*/
XtRealizeWidget(big_totake);
XQueryPointer(XtDisplay(big_totake), XtWindow(big_totake), &junk_win, &junk_win, &x_root, &y_root, &garbage, &garbage, &garbage_mask);
XtSetArg(Errtoptoptotake_arg[0],XtNx, x_root-20) ;
XtSetArg(Errtoptoptotake_arg[1],XtNy, y_root-20) ;
XtSetValues(big_totake, Errtoptoptotake_arg, XtNumber(Errtoptoptotake_arg));
XtMapWidget(big_totake);


/* Change the cursor ; beomes an arrow */
thedisplay = XtDisplay(the_title) ;
thewindow = XtWindow(the_title) ;
thecursor = XCreateFontCursor(thedisplay , XC_pirate) ;
XDefineCursor(thedisplay, thewindow , thecursor
) ;

thedisplay = XtDisplay(to_take) ;
thewindow = XtWindow(to_take) ;
thecursor = XCreateFontCursor(thedisplay , XC_question_arrow ) ;
XDefineCursor(thedisplay, thewindow , thecursor) ;

}

